#include <iostream>
#include <iomanip>

#include "TextDisplay.h"

using namespace std;

void TextDisplay::TextDisplay::show_round(const int round) const
{
    cout << endl << "Round " << round << endl;
}

void TextDisplay::update(const Choice human_choice,
                         const Choice computer_choice,
                         const Choice predicted_choice,
                         const Who winner,
                         const int human_wins,
                         const int computer_wins,
                         const int ties) const
{
    cout << "  Human chose " << human_choice << endl;
    cout << "  Computer predicted " << to_string(predicted_choice) << endl;
    cout << "  Computer chose " << computer_choice << endl;
    cout << "  Winner is " << winner << endl;
}

void TextDisplay::show_game_end(const int human_wins,
                                const int computer_wins,
                                const int ties,
                                const int max_rounds) const
{
    cout << endl;
    cout << "Game stats" << endl;
    cout << "----------" << endl;
    cout << "   Human wins:"  << right << setw(3)
         << human_wins << setw(4) << 100*human_wins/max_rounds << "%"
         << endl;
    cout << "Computer wins:" << right << setw(3)
         << computer_wins << setw(4) << 100*computer_wins/max_rounds << "%"
         << endl;
    cout << setw(14) << "Ties:" << right << setw(3) << ties
         << setw(4) << 100*ties/max_rounds << "%" << endl;
    cout << endl;
}
